#include "macro.sqf"
/*
	@version: 2.0
	@file_name: fn_loadGear.sqf
	@file_author: TAW_Tonic
	@file_edit: 9/24/2013
	@file_description: Load saved gear in old VAS format.
*/
private["_slot","_loadout","_primary","_launcher","_handgun","_magazines","_uniform","_vest","_backpack","_items","_primitems","_secitems","_handgunitems","_uitems","_vitems","_bitems","_handle"];
if(!isNil {VAS_loadout_ip}) exitWith {};
_slot = if(isNil {_this select 0}) then {lbCurSel VAS_load_list} else {_this select 0};
if(_slot == -1) exitWith {hint localize "STR_VAS_Prompt_slotSelFail";};
if(vas_disableLoadSave) then
{
	_loadout = missionNamespace getVariable format["vas_gear_new_%1",_slot];
}
	else
{
	_loadout = profileNamespace getVariable format["vas_gear_new_%1",_slot];
};

if(isNil {_loadout}) exitWith {}; //Slot data doesn't exist
VAS_loadout_ip = true;
_primary = _loadout select 1;
_launcher = _loadout select 2;
_handgun = _loadout select 3;
_magazines = _loadout select 4;
_uniform = _loadout select 5;
_vest = _loadout select 6;
_backpack = _loadout select 7;
_items = _loadout select 8;
_primitems = _loadout select 9;
_secitems = _loadout select 10;
_handgunitems = _loadout select 11;
_uitems = _loadout select 12;
_vitems = _loadout select 13;
_bitems = _loadout select 14;

//Strip the unit down
RemoveAllWeapons player;
{player removeMagazine _x;} foreach (magazines player);
removeUniform player;
removeVest player;
removeBackpack player;
removeGoggles player;
removeHeadGear player;
{
	player unassignItem _x;
	player removeItem _x;
} foreach (assignedItems player);

//Add the gear
if(_uniform != "") then {_handle = [_uniform,true,false,false,false] spawn VAS_fnc_handleItem; waitUntil {scriptDone _handle};};
if(_vest != "") then {_handle = [_vest,true,false,false,false] spawn VAS_fnc_handleItem; waitUntil {scriptDone _handle};};
if(_backpack != "") then {_handle = [_backpack,true,false,false,false] spawn VAS_fnc_handleItem; waitUntil {scriptDone _handle};};
_grenades=[];
_fnc_isGrenade = {
	//diag_log [_this,isClass(configFile/"CfgMagazines"/_this)];
	if (isClass(configFile/"CfgMagazines"/_this) && {isText(configFile/"CfgMagazines"/_this/"ammo")}) then {
		//diag_log ["ammo",getText(configFile/"CfgMagazines"/_this/"ammo")];
		(getText(configFile/"CfgMagazines"/_this/"ammo") isKindOf "Grenade");
	} else {
		false;
	};
};

{
	// TYRGHEN - added check for grenades
	if (_x call _fnc_isGrenade) then {
		_grenades set [count _grenades, _x];
	} else {
		_handle = [_x,true,false,false,false] spawn VAS_fnc_handleItem;
		waitUntil {scriptDone _handle};
	};
} foreach _magazines;
//diag_log ["Magazines",_magazines];

if(_primary != "") then {[_primary,true,false,false,false] spawn VAS_fnc_handleItem;};
if(_launcher != "") then {[_launcher,true,false,false,false] spawn VAS_fnc_handleItem;};
if(_handgun != "") then {[_handgun,true,false,false,false] spawn VAS_fnc_handleItem;};

{
	// TYRGHEN - added check for grenades
	if (_x call _fnc_isGrenade) then {
		_grenades set [count _grenades, _x];
	} else {
		_handle = [_x,true,false,false,false] spawn VAS_fnc_handleItem; waitUntil {scriptDone _handle};
	};
} foreach _items;
//diag_log ["Items",_items];
{
	// TYRGHEN - added check for grenades
	if (_x call _fnc_isGrenade) then {
		_grenades set [count _grenades, _x];
	} else {
		[_x,true,false,false,true,true] call VAS_fnc_handleItem;
	};
} foreach (_uitems);
//diag_log ["Uniform",_uitems];
{
	// TYRGHEN - added check for grenades
	if (_x call _fnc_isGrenade) then {
		_grenades set [count _grenades, _x];
	} else {
		[_x,true,false,false,true,false,true] call VAS_fnc_handleItem;
	};
} foreach (_vitems);
//diag_log ["Vest",_vitems];
{
	// TYRGHEN - added check for grenades
	if (_x call _fnc_isGrenade) then {
		_grenades set [count _grenades, _x];
	} else {
		[_x,true,true,false,false] call VAS_fnc_handleItem;
	};
} foreach (_bitems);
//diag_log ["Backpack",_bitems];
{[_x,true,false,true,false] call VAS_fnc_handleItem;} foreach (_primitems);
{[_x,true,false,true,false] call VAS_fnc_handleItem;} foreach (_secitems);
{[_x,true,false,true,false] call VAS_fnc_handleItem;} foreach (_handgunitems);  

// TYRGHEN
//diag_log ["Grenades",_grenades];
_grenades spawn {
	sleep 0.5;
	{ player addMagazine _x;
	} foreach _this;
};

if(primaryWeapon player != "") then
{
	player selectWeapon (primaryWeapon player);
};
VAS_loadout_ip = nil;